#include <algorithm>
#include <chrono>
#include <cmath>
#include <cstring>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <random>
#include <string>
#include <vector>

using namespace std;

#define Pop(stack) stack[--stack##_fill_pointer]
#define Push(item, stack) stack[stack##_fill_pointer++] = item

//#define NDEBUG

typedef long long llong;
typedef unsigned int uint;

struct Edge {
  int v1;
  int v2;
};

chrono::steady_clock::time_point start;

llong max_steps;
llong step;
int try_step;
uint seed;
int cutoff_time;
int mode;

int v_num;
int e_num;

Edge *edge;
int *edge_weight;

int *score;
// int *sub_score;
llong *time_stamp;
double s_alpha;
double s_beta;
double s_gamma;

int *v_weight;
int **v_edges;
int **v_adj;
int *v_degree;
int *v_threshold;
int *v_fixed;

int *dominated;
int c_size;
int *v_in_c;
int *candidate;
int *index_in_candidate;
int candidate_size;
llong now_weight;

int best_c_size;
int *best_v_in_c;
int *best_dominated;
double best_comp_time;
llong best_step;

int *undom_stack;
int undom_stack_fill_pointer;
int *index_in_undom_stack;

int *conf_change;
int *conf_count;

int ave_weight;
int s_gamma_total_weight;
int threshold;
double p_scale;

int para1;
int para2;
int para3;
int para4;
int para;

llong check_size = 0;


int *must_in;
int *record_in;
int must_in_beg = 0;
int must_in_end = 0;
